//+------------------------------------------------------------------+
//|                                                  C_SubWindow.mqh |
//|                                                      Daniel Jose |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Daniel Jose"
//+------------------------------------------------------------------+
#include "Chart IDE\\C_Chart_IDE.mqh"
//+------------------------------------------------------------------+
class C_SubWindow : public C_Chart_IDE
{
#define def_Indicador "SubWinSupport"
//+------------------------------------------------------------------+
	private	:
		int	m_IdSubWinEA;
//+------------------------------------------------------------------+
		void Init(void)
			{
				int i0;
				if ((i0 = ChartWindowFind(Terminal.Get_ID(), def_Indicador)) == -1)
					ChartIndicatorAdd(Terminal.Get_ID(), i0 = (int)ChartGetInteger(Terminal.Get_ID(), CHART_WINDOWS_TOTAL), iCustom(NULL, 0, "::" + def_Resource));
				m_IdSubWinEA = i0;
			}
//+------------------------------------------------------------------+
	public	:
//+------------------------------------------------------------------+
		C_SubWindow() : m_IdSubWinEA(-1)
			{
			}
//+------------------------------------------------------------------+
		~C_SubWindow()
			{
				Close();
			}	
//+------------------------------------------------------------------+
		void Close(void)
			{
				if (m_IdSubWinEA >= 0) ChartIndicatorDelete(Terminal.Get_ID(), m_IdSubWinEA, def_Indicador);
				m_IdSubWinEA = -1;
				CloseAlls();
			}
//+------------------------------------------------------------------+
inline int GetIdSubWinEA(void)
			{
				if (m_IdSubWinEA < 0) Init();
				return m_IdSubWinEA;
			}
//+------------------------------------------------------------------+
inline bool ExistSubWin(void) const { return m_IdSubWinEA >= 0; }
//+------------------------------------------------------------------+
#undef def_Indicador
};
//+------------------------------------------------------------------+
